/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package moe.nekojimi.nodeprocessor.links;

import moe.nekojimi.nodeprocessor.ports.ConstantOutPort;
import moe.nekojimi.nodeprocessor.ports.InPort;


public class ConstantLink<T> extends Link<T, InPort<T>, ConstantOutPort<T>>
{

    T value = null;

    public ConstantLink(ConstantOutPort<T> from, InPort<T> to)
    {
        super(from, to);
    }

    @Override
    public T read()
    {
        return value;
    }

    @Override
    public void write(T val)
    {
        if (val != value)
            signal();
        value = val;
    }

    @Override
    public boolean has()
    {
        return value != null;
    }

}
