/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package moe.nekojimi.nodeprocessor.links;

import moe.nekojimi.nodeprocessor.ports.InPort;
import moe.nekojimi.nodeprocessor.ports.PullOutPort;


public class PullLink<T> extends Link<T, InPort<T>, PullOutPort<T>>
{

    public PullLink(PullOutPort<T> from, InPort<T> to)
    {
        super(from, to);
    }

    @Override
    public T read()
    {
        return from.pull();
    }

    @Override
    public void write(T val)
    {
        // not used
    }

    @Override
    public boolean has()
    {
        return true;
    }

}
