/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package moe.nekojimi.nodeprocessor.ports;

import java.util.function.Supplier;
import moe.nekojimi.nodeprocessor.nodes.Node;

public class PullOutPort<T> extends OutPort<T>
{

    private Supplier<T> supplier;

    public PullOutPort(String name, Class<T> clazz, Node node)
    {
        super(name, clazz, node);
    }

    public void setSupplier(Supplier<T> supplier)
    {
        this.supplier = supplier;
    }

    @Override
    public void set(T value)
    {
        // not used
    }

    public T pull()
    {
        return supplier.get();
    }

}
